<?
global $baseSectionFilter;
$baseSectionFilter = array("CODE" => $_REQUEST["ELEMENT_CODE"]);

define("COMMON_PATH", "/bitrix/templates/common/");
// добавить, если надо
//define("BASE_URL", "http://template/");

// роутинг
include("routing.php");

// подключение языковых файлов
AddEventHandler("main", "OnBeforeProlog", "SiteLanguage::includeLangFile");

function getInfoPath () {
    global $APPLICATION;
    $curPage = $APPLICATION->GetCurPage(true);
    $lastDotPos = strrpos($curPage, ".");
    $beforeDot = substr($curPage, 0, $lastDotPos);
    $curInfoPage = $_SERVER["DOCUMENT_ROOT"].$beforeDot.".info.php";

    if (file_exists($curInfoPage) && is_file($curInfoPage) && ($infoContent = file_get_contents($curInfoPage))) {
        return $curInfoPage;
    }

    return false;
}

function ShowPageInfo()
{
    global $APPLICATION;
    $curPage = $APPLICATION->GetCurPage(true);
    $lastDotPos = strrpos($curPage, ".");
    $beforeDot = substr($curPage, 0, $lastDotPos);
    $curInfoPage = $_SERVER["DOCUMENT_ROOT"].$beforeDot.".info.php";

    /*$this->AddEditAction(
        "Идентификатор_области",
        "URL страницы, которая откроется в popup-окне",
        "Название кнопки в toolbar",
        Array(
            "WINDOW" => array("wight"=>780, "height"=>500),
            "ICON" => "bx-content-toolbar-edit-icon",
            "SRC" => "/bitrix/images/myicon.gif"
        )
    );*/

    if (file_exists($curInfoPage) && is_file($curInfoPage) && ($infoContent = file_get_contents($curInfoPage))) {
        return <<<EOT
    $infoContent
EOT;

    }

    return "";
}

class TL {
    public static function getCSS($path, $section = "header") {
        if (!session_id()) session_start();

        if ($section == "header") {
            if (!$_SESSION["styleInjected"]) {
                return "<style>" . file_get_contents($_SERVER["DOCUMENT_ROOT"] . $path) . "</style>";
            } else {
                return "<link type=\"text/css\" rel=\"stylesheet\" href=\"" . $path . "\">";
            }
        }

        if ($section == "footer") {
            if (!$_SESSION["styleInjected"]) {
                $_SESSION["styleInjected"] = true;
                return "<link type=\"text/css\" rel=\"stylesheet\" href=\"" . $path . "\" property=\"\">";
            }
        }

        return "";
    }

    public static function includeFile($name, $lang = false) {
        global $APPLICATION;

        $name = (stripos($name, ".php") !== false) ? $name : $name . ".php";
        $path = ($lang) ? LANGUAGE_ID . "/" . $name : $name;

        $APPLICATION->IncludeComponent(
            "bitrix:main.include",
            "",
            Array(
                "AREA_FILE_SHOW" => "file",
                "PATH" => COMMON_PATH . "include/" . $path,
                "AREA_FILE_SUFFIX" => "",
                "EDIT_TEMPLATE" => ""
            ),
            false,
            array (
                "HIDE_ICONS" => "Y",
                "ACTIVE_COMPONENT" => "Y"
            )
        );
    }

    public static function includeWeather($name, $lang = false) {
        global $APPLICATION;

        $name = (stripos($name, ".php") !== false) ? $name : $name . ".php";
        $path = ($lang) ? LANGUAGE_ID . "/" . $name : $name;

        $APPLICATION->IncludeComponent(
            "bitrix:main.include",
            "",
            Array(
                "AREA_FILE_SHOW" => "file",
                "PATH" => COMMON_PATH . "include/tlweather/" . $path,
                "AREA_FILE_SUFFIX" => "",
                "EDIT_TEMPLATE" => ""
            ),
            false,
            array (
                "HIDE_ICONS" => "Y",
                "ACTIVE_COMPONENT" => "Y"
            )
        );
    }

    public static function includeHotelFile($name, $lang = false) {
        TL::includeFile(HOTEL . "/" . $name, $lang);
    }

    public static function includeComponent($name) {
        TL::includeFile("components/$name", false);
    }

    public static function getCurrentElement($arResult, $url, $getParameter = "ELEMENT_CODE", $getNeighbors = false, &$neighborsArr = array()) {
        for ($i = 0; $i < count($arResult["ITEMS"]); $i ++) {
            $arElement = $arResult["ITEMS"][$i];
            if ($arElement["CODE"] == $_GET[$getParameter]) {
                if ($getNeighbors) {
                    $neighborsArr["PREV"] = isset($arResult["ITEMS"][$i - 1]) ? $arResult["ITEMS"][$i - 1] : false;
                    $neighborsArr["NEXT"] = isset($arResult["ITEMS"][$i + 1]) ? $arResult["ITEMS"][$i + 1] : false;
                }
                return $arElement;
            }
        }

        LocalRedirect($url);
    }

    public static function getSectionProperties($sectionId) {
        $sectionProps = array();

        $rsParentSection = CIBlockSection::GetByID($sectionId);
        while ($arParentSection = $rsParentSection->GetNext()) {
            $sectionProps["NAME"] = $arParentSection["NAME"];
            $sectionProps["CODE"] = $arParentSection["CODE"];
        }

        return $sectionProps;
    }

    public static function cropString($string, $limit) {
        if (strlen($string) >= $limit) {
            $substring = mb_substr($string, 0, $limit);
            return mb_substr($substring, 0, mb_strrpos($substring, " ")) . "...";
        } else {
            return $string;
        }
    }

    public static function getCustomList($array, $listClass="b-list", $itemClass="item", $delimiter=";") {
        if (!is_array($array) || empty($array))  {
            return "";
        }

        $result = "<ul class='".$listClass."'><li class='".$itemClass."'>";
        $result .= join($delimiter."</li><li class='".$itemClass."'>", $array);
        $result .= ".</li></ul>";

        return $result;
    }

    public static function getDefaultList($arrayValue) {
        ob_start();
        ?>
        <ul class="b-list">
            <?foreach ($arrayValue as $item):?>
                <li><?=$item?></li>
            <?endforeach?>
        </ul>
        <?//jjj
        $strReturn = ob_get_clean();
        return $strReturn;
    }

    public static function getHotelFields($code) {
        $hotelFields = array();

        $dbElements = CIBlockElement::GetList(Array(), Array("IBLOCK_TYPE"=>"hotels", "IBLOCK_ID"=>"10", "ELEMENT_CODE" => $code));
        if($obEl = $dbElements->GetNextElement())
        {
            $hotelFields = $obEl->GetFields();
        }

        return $hotelFields;
    }

    public static function getHotelProperties($code) {
        $hotelProps = array();

        $dbElements = CIBlockElement::GetList(Array(), Array("IBLOCK_TYPE"=>"hotels", "IBLOCK_ID"=>"10", "ELEMENT_CODE" => $code));
        if($obEl = $dbElements->GetNextElement())
        {
            $hotelProps = $obEl->GetProperties();
        }

        return $hotelProps;
    }

    public static function getElementProperties($id) {
        $elemProps = array();
        if (CModule::IncludeModule("iblock")) {
            $dbElements = CIBlockElement::GetList(
                array("SORT" => "ASC"),
                array("IBLOCK_ID"=>"10", "IBLOCK_TYPE"=>"hotels", "ELEMENT_ID" => $id, "ACTIVE" => "Y")
            );

            if($obEl = $dbElements->GetNextElement())
            {
                $elemProps = $obEl->GetProperties();
            }

            return $elemProps;
        }

    }

    public static function getBookingUrl ($roomType) {
        $bookingUrl = SITE_DIR."booking/";
        if ($roomType) {
            return $bookingUrl."?room-type=".$roomType;
        }
        else {
            return $bookingUrl;
        }
    }

    public static function getOfferUrl ($offerId) {
        $bookingUrl = SITE_DIR."booking/";
        if ($offerId) {
            return $bookingUrl."?special-offer=".$offerId;
        }
        else {
            return $bookingUrl;
        }
    }

    public static function getFirstImage($galleryId) {
        CModule::IncludeModule('iblock');

        $arSelect = Array("PREVIEW_PICTURE");
        $arFilter = Array("IBLOCK_ID" => 4, "SECTION_ID" => IntVal($galleryId), "ACTIVE" => "Y");

        $list = CIBlockElement::GetList(Array("SORT" => "ASC", "ID" => "ASC"), $arFilter, false, Array("nPageSize" => 50), $arSelect);

        while($item = $list->GetNextElement())
        {
            $arFields = $item->GetFields();
            $imageId = $arFields["PREVIEW_PICTURE"];

            if ($imageId) {
                return $imageId;
            }

        }
        return '';
    }
}

class Tools {
    private static function returnOutput($callback, $args = array()) {
        ob_start();
        call_user_func_array($callback, $args);
        $strResult = ob_get_contents();
        ob_clean();
        ob_end_clean();
        return $strResult;
    }
    public static function getPageClass() {
        global $APPLICATION;
        return $APPLICATION->AddBufferContent(Array(Tools, "getPageClassBuffer"));
    }
    public static function getPageClassBuffer() {
        global $APPLICATION;
        return "b-page ".$APPLICATION->GetPageProperty("pageClass");
    }
    public static function getFile($file) {
        global $APPLICATION;
        return $APPLICATION->AddBufferContent(Array(Tools, "getFileBuffer"), $file);
    }
    public static function getFileBuffer($file) {
        return Tools::returnOutput(array(TL, "includeFile"), array($file));
    }
}

// Оповещение о новом отзыве в новости

function notifyNewItemFeedback($ID, $arFields)
{
	CModule::IncludeModule("iblock");

    ob_start();
    $res = CIBlockElement::GetList(
        array(),
        array(
            'IBLOCK_ID' => 7,
            'PROPERTY_FORUM_TOPIC_ID' => $arFields["TOPIC_ID"]
        ),
        false,
        false,
        array('*', 'IBLOCK_ID', 'ID', 'NAME', 'PROPERTY_FORUM_TOPIC_ID', 'SECTION_ID', 'SECTION', 'SECTIONS')
);
if($ar_res = $res->GetNext())
    {

        $TYPE_MAIL_EVENT = 'NEW_ITEM_REVIEW';
        $arMail = array(
            'ITEM_NAME' => $ar_res['NAME'],
            'AUTHOR_NAME' => $arFields['AUTHOR_NAME'],
            'POST_DATE' => date('d.m.Y H:i:s'),
            'POST_MESSAGE' => $arFields['POST_MESSAGE'],
            'PATH2ITEM' => '/catalog/' . $ar_res['IBLOCK_SECTION_ID'] . '/' . $ar_res['ID'],
        );
        $ID_MAIL_EVENT = 26;
        CEvent::SendImmediate($TYPE_MAIL_EVENT, "s1", $arMail, $ID_MAIL_EVENT);
        ob_get_clean();
    }
}

AddEventHandler("forum", "onAfterMessageAdd", "notifyNewItemFeedback");
?>